                                                                                                                                                                                                        /*
* @(#)Arquitetura.java  1.0  30/03/2001
*	
* Aline Vieira de Mello
* Pontifcia Universidade Catlica do Rio Grande do Sul - Faculdade de Informtica
*/

import java.io.*;
import java.util.*;
import javax.swing.*;

/**
*<i>Arquitetura</i> transforma a arquitetura descrita na arquitetura padro.
*/
public class Arquitetura
{
	private Simulador sim;
	private ArqSim arqSim;
	private ArqMont arqMont;
	private String instrucao;
	private String arqarq;
	private String c[];
	private String cF[];
	private int indice;
	
	public Arquitetura(Simulador sim,String arqarq)
	{
		arqSim=new ArqSim();
		arqMont=new ArqMont();		
		this.sim=sim;
		this.arqarq=arqarq;
		c=new String[4];
		carregaArqSim();
		carregaArqMont();
	}
	
	/**
	*Retorna o apontador para Arquitetura padro do Simulador.
	*/
	public ArqSim getArqSim() {return arqSim;}
	
	/**
	*Retorna o apontador para Arquitetura descrita.
	*/
	public ArqMont getArqMont() {return arqMont;}
			
	/**
	*Carrega Arquitetura do Simulador.
	*/
	public void carregaArqSim()
	{
		arqSim.inclui("ADD","Op1","Rt","Rs1","Rs2");	
		arqSim.inclui("SUB","Op1","Rt","Rs1","Rs2");	
		arqSim.inclui("AND","Op1","Rt","Rs1","Rs2");	
		arqSim.inclui("OR","Op1","Rt","Rs1","Rs2");	
		arqSim.inclui("XOR","Op1","Rt","Rs1","Rs2");	
		
		arqSim.inclui("ADDI","Op1","Rt","Ct1","Ct2");	
		arqSim.inclui("SUBI","Op1","Rt","Ct1","Ct2");	
		arqSim.inclui("LDL","Op1","Rt","Ct1","Ct2");	
		arqSim.inclui("LDH","Op1","Rt","Ct1","Ct2");	
		
		arqSim.inclui("POP","Op1","Rt","Op2","Op3");	
		arqSim.inclui("PUSH","Op1","Op2","Rt","Op3");	
		
		arqSim.inclui("LD","Op1","Rt","Op2","Rs2");	
		arqSim.inclui("ST","Op1","Op2","Rs1","Rs2");	
		arqSim.inclui("LD2","Op1","Rt","Rs1","Rs2");	
		arqSim.inclui("ST2","Op1","Rt","Rs1","Rs2");	
		
		arqSim.inclui("SL","Op1","Rt","Op2","Rs2");	
		arqSim.inclui("SR","Op1","Rt","Op2","Rs2");	
		arqSim.inclui("NOT","Op1","Rt","Op2","Rs2");
		
		arqSim.inclui("DIF","Op1","Op2","Rs1","Rs2");	
		arqSim.inclui("EQL","Op1","Op2","Rs1","Rs2");	
		arqSim.inclui("SUP","Op1","Op2","Rs1","Rs2");	
		arqSim.inclui("INF","Op1","Op2","Rs1","Rs2");	
		arqSim.inclui("LDSP","Op1","Op2","Rs1","Op3");
		
		arqSim.inclui("NOP","Op1","Op2","Op3","Op4");	
		arqSim.inclui("RTS","Op1","Op2","Op3","Op4");	
		arqSim.inclui("HALT","Op1","Op2","Op3","Op4");	
		
		arqSim.inclui("JMPRC","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JSRRC","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JMPR","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JSRR","Op1","Op2","Rs1","Op3");	
		
		arqSim.inclui("JMPC","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JSRC","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JMP","Op1","Op2","Rs1","Op3");	
		arqSim.inclui("JSR","Op1","Op2","Rs1","Op3");	
		
		arqSim.inclui("JMPDC","Op1","Ct1","Ct2","Ct3");	
		arqSim.inclui("JSRDC","Op1","Ct1","Ct2","Ct3");
	  arqSim.inclui("JMPD","Op1","Ct1","Ct2","Ct3");	
		arqSim.inclui("JSRD","Op1","Ct1","Ct2","Ct3");
	  
		arqSim.inclui("JN","Op1","Op2","Op3","Rs1");
		arqSim.inclui("JZ","Op1","Op2","Op3","Rs1");
	  arqSim.inclui("JC","Op1","Op2","Op3","Rs1");
		arqSim.inclui("JV","Op1","Op2","Op3","Rs1");
		
		arqSim.inclui("JNR","Op1","Op2","Op3","Rs1");
		arqSim.inclui("JZR","Op1","Op2","Op3","Rs1");
	  arqSim.inclui("JCR","Op1","Op2","Op3","Rs1");
		arqSim.inclui("JVR","Op1","Op2","Op3","Rs1");

		arqSim.inclui("JND","Op1","Ct1","Ct2","Ct3");
		arqSim.inclui("JZD","Op1","Ct1","Ct2","Ct3");
	  arqSim.inclui("JCD","Op1","Ct1","Ct2","Ct3");
		arqSim.inclui("JVD","Op1","Ct1","Ct2","Ct3");
		
		arqSim.inclui("SL0","Op1","Rt","Op2","Rs1");
		arqSim.inclui("SL1","Op1","Rt","Op2","Rs1");
		arqSim.inclui("SR0","Op1","Rt","Op2","Rs1");
		arqSim.inclui("SR1","Op1","Rt","Op2","Rs1");
		
		arqSim.inclui("INC","Op1","Rt","Op2","Rs1");
		arqSim.inclui("DEC","Op1","Rt","Op2","Rs1");
		arqSim.inclui("NEG","Op1","Rt","Op2","Rs1");
		arqSim.inclui("MOV","Op1","Rt","Op2","Rs1");
	}
	
	/**
	*Abre o arquivo que contm a descrio da arquitetura e carrega
	*as instrues.
	*/
	public void carregaArqMont()
	{
		String lixo1;
		StringTokenizer st;
		String linha;
		String[] c,camp,flag;
		String mneu,inst,flagdep;
		int nflag,nclock;
			
		try
		{
			//Abre o arquivo para leitura.
			FileInputStream files=new FileInputStream(arqarq);
			DataInputStream d=new DataInputStream(files);
			BufferedReader dis = new BufferedReader(new InputStreamReader(files));
		  
		  //NOME ARQUITETURA
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$INST"));
			
			linha=dis.readLine();
		
			do
			{
				//Separando a linha em tokens			
				st=new StringTokenizer(linha);
				c=new String[4];
				camp=new String[4];
				flag=new String[10];
				
				//Lendo o Mneumonico e a instrucao associada
				mneu=st.nextToken();
				inst=st.nextToken();
								
				//Eliminando numero de registradores, constantes, labels e nclock.
				lixo1=st.nextToken();
				lixo1=st.nextToken();
				lixo1=st.nextToken();
				lixo1=st.nextToken();
				
				//Lendo o nmero de clocks
				nclock=Integer.valueOf(st.nextToken()).intValue();
							
				//Lendo o codigo da instrucao
				c[0]=st.nextToken();
				c[1]=st.nextToken();
				c[2]=st.nextToken();
				c[3]=st.nextToken();
			
				//Eliminando os campo de como deve ser montado
				lixo1=st.nextToken();
				lixo1=st.nextToken();
				lixo1=st.nextToken();
				lixo1=st.nextToken();
						
				//Lendo os campos da instrucao						
				camp[0]=st.nextToken();
				camp[1]=st.nextToken();
				camp[2]=st.nextToken();
				camp[3]=st.nextToken();
			
				//Lendo o flag dependende da instrucao
				linha=dis.readLine();
				st=new StringTokenizer(linha);
				lixo1=st.nextToken();
				flagdep=st.nextToken();
			
				//Lendo o numero de flags da instrucao
				linha=dis.readLine();
				st=new StringTokenizer(linha);
				lixo1=st.nextToken();
				nflag=Integer.valueOf(st.nextToken()).intValue();
			
				//Lendo os flags da instrucao
				int i=0;
				do
				{			
					linha=dis.readLine();
					st=new StringTokenizer(linha);
					lixo1=st.nextToken();
					if(!lixo1.equalsIgnoreCase("$ENDFLAGS"))
					{
						flag[i]=lixo1;
						i++;
					}
				}while(!lixo1.equalsIgnoreCase("$ENDFLAGS"));

				arqMont.inclui(mneu,inst,nclock,c[0],c[1],c[2],c[3],camp[0],camp[1],camp[2],camp[3],flagdep,nflag,flag);
				linha=dis.readLine();
			}
			while(!linha.equalsIgnoreCase("$ENDINST"));
			dis.close();
		}
		catch(FileNotFoundException f)
		{
			JOptionPane.showMessageDialog(sim.getJanela(),"ARQUIVO QUE CONTEM A ARQUITETURA \n DESCRITA NO ENCONTRADO","MENSAGEM DE ERRO", JOptionPane.ERROR_MESSAGE);
		}	
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(sim.getJanela(),"NO FOI POSSVEL ABRIR O ARQUIVO","MENSAGEM DE ERRO", JOptionPane.ERROR_MESSAGE);
		}	
		//arqMont.exibe();
	}
		
	/**
	*Seleciona a instrucao da nova Arquitetura.
	*/
	public String selecionaInstrucao(String[] c)
	{
		boolean achei,continua;
		NodoArqMont aux=arqMont.getInicio();
		achei=false;

		while(aux!=null)
		{
			continua=true;
			indice=aux.procura("Op1");
			//Verifica se existe o campo Op1. Caso existir,
			//verifica se  igual ao codigo do montador neste campo.
			if(indice!=-1)
			{
				if(aux.getCod(indice).equalsIgnoreCase(c[indice]))
				{
					continua=true;
				}
				else
					continua=false;					
			}

			//Verifica se existe o campo Op2. Caso existir,
			//verifica se  igual ao codigo do montador neste campo.
			if(continua)
			{
				indice=aux.procura("Op2");
				if(indice!=-1)
				{
					if(aux.getCod(indice).equalsIgnoreCase(c[indice]))
						continua=true;
					else
						continua=false;					
				}
			}				
			
			//Verifica se existe o campo Op3. Caso existir,
			//verifica se  igual ao codigo do montador neste campo.
			if(continua)
			{
				indice=aux.procura("Op3");
				if(indice!=-1)
				{
					if(aux.getCod(indice).equalsIgnoreCase(c[indice]))
						continua=true;
					else
						continua=false;					
				}
			}
			
			//Verifica se existe o campo Op4. Caso existir,
			//verifica se  igual ao codigo do montador neste campo.
			if(continua)
			{
				indice=aux.procura("Op4");
				if(indice!=-1)
				{
					if(aux.getCod(indice).equalsIgnoreCase(c[indice]))
						continua=true;
					else
						continua=false;					
				}
			}
			
			//Se Todos os Ops existentes forem iguais aos codigos do
			//montador, a instrucao foi encontrada.
			if(continua)
				return aux.getInstrucao();
			aux=aux.getProx();
		}
		return null;
	}
}