/*
* @(#)Configurador.java  1.0  30/03/2001
*	
* Aline Vieira de Mello
* Pontifcia Universidade Catlica do Rio Grande do Sul - Faculdade de Informtica
*/

import javax.swing.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.lang.*;

/**
*<i>Configurador</i> implementa a janela que inclui o arquivo da arquitetura
*descrita atravs do Configurador de Arquiteturas para a simulao.
*/
public class Configurador extends JFrame implements ActionListener
{
	private JLabel informacao,informacao2;
	private JTextField arq;
	private JButton ok,configurador;	
	private String arquitetura,caminho;
	private JFileChooser fc;
	private File ultimodiretorio;
	private FileChooserDemo fcd;
	
	public Configurador()
	{
		super();
		setTitle("Simulador de Arquiteturas");
 		getContentPane().setLayout(null);
	  setSize(345,160);
	  setLocation(221,220);
    addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});
  	ultimodiretorio=new File(System.getProperty("user.dir"));
  	fcd=new FileChooserDemo();
	  implementa();	
	}
	
	/**
	*Descreve o mtodo nativo que executa o arquivo Config.bat. 
	*/
	public native static void chamaConfig();
	static
	{
		System.loadLibrary("Configurador");
	}
	
	
	/**
	*Implementa o layout da janela.
	*/
	public void implementa()
	{
		implementaMenu();
		
		//Figura GAPH
	  Canvas_Gif canvas=new Canvas_Gif();
	  canvas.setBounds(190,5,160,60);
		getContentPane().add(canvas);
	
		informacao=new JLabel("Dever ser informado qual a");
		informacao.setBounds(15,10,350,20);
		getContentPane().add(informacao);
		
		informacao2=new JLabel("arquitetura ser simulada.");
		informacao2.setBounds(15,30,350,20);
		getContentPane().add(informacao2);
		
		arq=new JTextField();
		arq.setBounds(35,65,200,30);
		getContentPane().add(arq);
		
		ok=new JButton("Ok");
		ok.setBounds(245,65,50,30);
		ok.addActionListener(this);
		getContentPane().add(ok);
		setVisible(true);
	}	

	/**
	*implementa Menu para a janela.
	*/
	public void implementaMenu()
	{
		JMenuBar menu=new JMenuBar();
		JMenu abrir=new JMenu("Abrir");
		
		//Itens do Menu Abrir
		JMenuItem abrirArq=new JMenuItem("Abrir Arquitetura");
		abrirArq.addActionListener(this);
		abrir.add(abrirArq);
		abrir.addSeparator();
		JMenuItem sairArq=new JMenuItem("Sair");
		sairArq.addActionListener(this);
		abrir.add(sairArq);
				
		menu.add(abrir);
		setJMenuBar(menu);
	}


	
	/**
	*Grava arquivo BAT com as linhas para a execuo do programa
	*Configurador de Arquiteturas.
	*/
	public void gravaArquivoBat()
	{	

		String diretorio;
		
		try
		{
			FileOutputStream fos=new FileOutputStream("Config.bat");
			DataOutputStream dos=new DataOutputStream(fos);
			
			dos.writeBytes("cd..");
			dos.writeBytes("\r\ncd Configurador");
			dos.writeBytes("\r\njava Configurador S");
			dos.close();
		}	
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(this,"NO FOI POSSVEL SALVAR O ARQUIVO .BAT","MENSAGEM DE ERRO", JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	*Implementao da ActionListener com a execuo dos botes.
	*/
	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equalsIgnoreCase("OK"))
		{
			arquitetura=arq.getText();	
			if(arquitetura.length()>4)
			{
				if(!arquitetura.substring(arquitetura.length()-4,arquitetura.length()).equalsIgnoreCase(".arq"))
					arquitetura=arquitetura.concat(".arq");	
			}
			else
			{
				arquitetura=arquitetura.concat(".arq");	
			}
			dispose();
			Simulador sim=new Simulador(arquitetura);
		  sim.imp();	
		}
		else if(e.getActionCommand().equalsIgnoreCase("Configurador de Arquiteturas"))
		{
			gravaArquivoBat();
			chamaConfig();
		}
		else if(e.getActionCommand().equalsIgnoreCase("Abrir Arquitetura"))
		{
			fc = new JFileChooser(ultimodiretorio);
    
    	//Filtra somente os diretorios e arquivos .arq.
    	fc.setFileFilter(new FiltraArquivos("arq"));
    
    	//FileChosser para abrir arquivo.
    	int returnVal = fc.showOpenDialog(fcd);
    
    	//verifica se foi clicado sobre Open.
    	if (returnVal == JFileChooser.APPROVE_OPTION) 
			{
	    	//Captura o arquivo aberto.
	    	File file = fc.getSelectedFile();
	   		ultimodiretorio=fc.getCurrentDirectory();
       	arq.setText(file.getName());
	    }
		}
		else if(e.getActionCommand().equalsIgnoreCase("Sair"))
			System.exit(0);
	}
}