/*
* @(#)Conversao.java  1.0  30/03/2001
*	
* Aline Vieira de Mello
* Pontifcia Universidade Catlica do Rio Grande do Sul - Faculdade de Informtica
*/

/**
*<i>Converso</i> converte valores do tipo HEXADECIMAL, DECIMAL e
*BINARIO.
*/
public class Conversao
{
	private String codigo1,codigo2,codigo3,codigo4;
	private Simulador sim;
	
	public Conversao(Simulador sim)
	{
		this.sim=sim;
	}
	
	/**
	*Recebe o cdigo de 4 bits que deve ser convertido.
	*/
	public void setCodigo(String cod1,String cod2,String cod3,String cod4)
	{
		codigo1=cod1;
		codigo2=cod2;
		codigo3=cod3;
		codigo4=cod4;
	}
	
	/**
	*Converte um valor em HEXADECIMAL para DECIMAL. 
	*/
	public int hexa_decimal(String valorhex)
	{
		String codigo[],cod;
		int dec,decimal,i,j,tam,indice;
		
		tam=(valorhex.length());
		codigo=new String[tam];
		
		//Separa bit por bit para a converso.
		for(indice=0;indice<tam;indice++)
			codigo[indice]=(valorhex.substring(indice,indice+1));
		
		//Converte bit a bit para DECIMAL.
		decimal=0;
		for(i=0,j=tam-1;i<tam;i++,j--)
		{
			cod=codigo[i];
			
			if(cod.equalsIgnoreCase("0"))
					dec=0;
			else if(cod.equalsIgnoreCase("1"))
					dec=1;
			else if(cod.equalsIgnoreCase("2"))
					dec=2;
			else if(cod.equalsIgnoreCase("3"))
					dec=3;
			else if(cod.equalsIgnoreCase("4"))
					dec=4;
			else if(cod.equalsIgnoreCase("5"))
					dec=5;
			else if(cod.equalsIgnoreCase("6"))
					dec=6;
			else if(cod.equalsIgnoreCase("7"))
					dec=7;
			else if(cod.equalsIgnoreCase("8"))
					dec=8;
			else if(cod.equalsIgnoreCase("9"))
					dec=9;
			else if(cod.equalsIgnoreCase("A"))
					dec=10;
			else if(cod.equalsIgnoreCase("B"))
					dec=11;
			else if(cod.equalsIgnoreCase("C"))
					dec=12;
			else if(cod.equalsIgnoreCase("D"))
					dec=13;
			else if(cod.equalsIgnoreCase("E"))
					dec=14;
			else
					dec=15;

			dec=dec*(exp(16,j));
			decimal=decimal+dec;
		}
		return decimal;
	}
				
	/**
	*Converte um valor em BINARIO para DECIMAL. 
	*/
	public int binario_decimal(String valor)
	{
		String codigo[],cod;
		int dec,decimal,i,j,tam,indice;
		
		tam=(valor.length());
		codigo=new String[tam];
		
		//Separa bit por bit para a converso.
		for(indice=0;indice<tam;indice++)
			codigo[indice]=(valor.substring(indice,indice+1));
		
		//Converte bit a bit para DECIMAL.
		decimal=0;
		for(i=0,j=tam-1;i<tam;i++,j--)
		{
			cod=codigo[i];
			
			if(cod.equalsIgnoreCase("0"))
					dec=0;
			else
					dec=1;

			dec=dec*(exp(2,j));
			decimal=decimal+dec;
		}
		return decimal;
	}
	
	/**
	*Funo Exponencial. 
	*/
	public int exp(int base,int expoente)
	{
		if(expoente==0)
			return 1;
		else
   	{
			int exp=base;
			for(int i=0;i<(expoente-1);i++)
      	exp=exp*base;
			return exp;
   	}
	}

	/**
	*Converte um valor em DECIMAL para HEXADECIMAL. 
	*/
	public String decimal_hexa(int valor)
	{
		String hexadecimal,hexa,zero;
   	int div,resto,tam,i;

   	//Se o valor decimal  negativo, deve se diminu-lo do tamanho
   	//da memria. 
   	if(valor<0)
   		valor=65536+valor;
   		
   	//Converte
   	hexadecimal="";
   	do
   	{
   		resto=(valor%16);
			valor=valor/16;
			if(resto==0)
				hexa="0";
			else if(resto==1)
				hexa="1";
			else if(resto==2)
				hexa="2";
			else if(resto==3)
				hexa="3";
			else if(resto==4)
				hexa="4";
			else if(resto==5)
				hexa="5";
			else if(resto==6)
				hexa="6";
			else if(resto==7)
				hexa="7";
			else if(resto==8)
				hexa="8";
			else if(resto==9)
				hexa="9";
			else if(resto==10)
				hexa="A";
			else if(resto==11)
				hexa="B";
			else if(resto==12)
				hexa="C";
			else if(resto==13)
				hexa="D";
			else if(resto==14)
				hexa="E";
			else
				hexa="F";
			
			hexadecimal=hexa.concat(hexadecimal);
   	}while(valor!=0);
   	
   	zero="0";
   	tam=4-hexadecimal.length();
   	for(i=0;i<tam;i++)
   		hexadecimal=zero.concat(hexadecimal);
   		
   	return hexadecimal;
	}
	
	/**
	*Converte um valor em DECIMAL para BINARIO.
	*/
	public String decimal_binario(int numero)
	{
		String binario,bin,zero;
  	int resto,tam,i;

   	binario="";
  	bin="";
		do
   	{
			resto=(numero%2);
			numero=numero/2;
			if(resto==0)
				bin="0";
			else if(resto==1)
				bin="1";
			binario=bin.concat(binario);
		}while(numero!=0);

   	zero="0";
   	tam=16-binario.length();
   	for(i=0;i<tam;i++)
   		binario=zero.concat(binario);
   	
   	return binario;
	}
}