/*
* @(#)Simulador.java  1.0  30/03/2001
*	
* @autor Aline Vieira de Mello
* Pontifcia Universidade Catlica do Rio Grande do Sul - Faculdade de Informtica
*/

import java.util.*;
import java.io.*;
import javax.swing.*;

/**
* <i>Simulador</i> seleciona a arquitetura e executa o simulador a partir da descrio
* contida no arquivo da arquitetura.
*/
public class Simulador 
{
	private Conversao conversao;
	private Memoria memoria;
	private Variaveis variavel;
	private	Janela janela;
	private Arquivo arquivo;
	private Arquitetura arquitetura;
	private Execucao execucao;
	private int tamanhoMemoria;
	private int numeroVariaveis;
	private int tamanhoPalavra;
	private int nflag;
	private String posicaoSP,nomeArquitetura,movpilha;
	private String arqarq;

	public Simulador(String arquitetura)
	{
		arqarq=arquitetura;
	}
	public static void main(String s[])
	{
		String arquitetura;
		try
		{
			arquitetura=s[0];
			if(arquitetura.length()>4)
			{
				if(!arquitetura.substring(arquitetura.length()-4,arquitetura.length()).equalsIgnoreCase(".arq"))
					arquitetura=arquitetura.concat(".arq");
			}
			else
			{
				arquitetura=arquitetura.concat(".arq");
			}
			Simulador sim=new Simulador(arquitetura);
			sim.imp();
		}catch(ArrayIndexOutOfBoundsException e )
		{
			Configurador config=new Configurador();
		}
	}

	//Retorna as variaveis
	public Conversao getConversao(){return conversao;}
	public Memoria getMemoria(){return memoria;}
	public Variaveis getVariavel(){return variavel;}
	public Janela getJanela(){return janela;}
	public Arquivo getArquivo(){return arquivo;}
	public Arquitetura getArquitetura(){return arquitetura;}
	public Execucao getExecucao(){return execucao;}
	public String getNomeArquitetura(){return nomeArquitetura;}
	public String  getMovPilha() {return movpilha;}
	public int getTamanhoMemoria(){return tamanhoMemoria;}
	public int getNumeroVariaveis(){return numeroVariaveis;}
	public String getPosicaoSP(){return posicaoSP;}
	public int getNflag(){return nflag;}
	
	//Seta as variaveis
	public void setTamanhoMemoria(int t){tamanhoMemoria=t;}
	public void setNumeroVariaveis(int n){numeroVariaveis=n;}
	
	/**
	*Implementa o Simulador.
	*/
	public void imp()
	{
		int nreg=0;
		String[]flags;
		String linha;
		StringTokenizer st;
		
		flags=new String[10];
		nflag=0;
		movpilha="";
		
		try
		{
			//Abre o arquivo para leitura.
			FileInputStream files=new FileInputStream(arqarq);
			DataInputStream d=new DataInputStream(files);
			BufferedReader dis = new BufferedReader(new InputStreamReader(files));
		  
		  //NOME ARQUITETURA
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$ARQ"));
			linha=dis.readLine();
			st=new StringTokenizer(linha);
			linha=st.nextToken();
			nomeArquitetura="Simulador ";
			nomeArquitetura=nomeArquitetura.concat(linha);
			
			//TAMANHO MEMORIA
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$TAMMEMORIA"));
			linha=dis.readLine();
			st=new StringTokenizer(linha);
			linha=st.nextToken();
			tamanhoMemoria=Integer.valueOf(linha).intValue();

			//REGS
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$REG"));
			linha=dis.readLine();
		  st=new StringTokenizer(linha);
			linha=st.nextToken();
			nreg = Integer.valueOf(linha).intValue();
			
			//FLAGS
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$FLAG"));
			linha=dis.readLine();
			while(!linha.equalsIgnoreCase("$ENDFLAG"))
			{
				st=new StringTokenizer(linha);
				linha=st.nextToken();
				flags[nflag]=linha;
				nflag++;
				linha=dis.readLine();
			}
			
			//PILHA
			do
			{
				linha=dis.readLine();
			}while(!linha.equalsIgnoreCase("$PILHA"));
			linha=dis.readLine();
			st=new StringTokenizer(linha);
			linha=st.nextToken();
			movpilha=linha;
			
			dis.close();
			
			//EXIBE
			/*
			System.out.println("narq="+nomeArquitetura);
			System.out.println("tammem="+tamanhoMemoria);
			System.out.println("nreg="+nreg);
			System.out.println("nflag="+nflag);
			for(int i=0;i<nflag;i++)
				System.out.println(flags[i]);
			System.out.println("movpilha="+movpilha);
			*/
		}
		catch(FileNotFoundException f)
		{
			JOptionPane.showMessageDialog(null,"A ARQUITETURA NO ENCONTRADA","MENSAGEM DE ERRO", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}
		catch(Exception e)
		{
		}
		
		conversao=new Conversao(this);
		
		numeroVariaveis=100; //Default	
		if(movpilha.equalsIgnoreCase("INC"))
			posicaoSP=conversao.decimal_hexa(tamanhoMemoria-((tamanhoMemoria/100)*10));
		else	
			posicaoSP=conversao.decimal_hexa(tamanhoMemoria-1);
	
		memoria=new Memoria(this);
		
		variavel=new Variaveis(this);
		
		arquivo=new Arquivo(this,arqarq);
		
		arquitetura=new Arquitetura(this,arqarq);
		
		execucao=new Execucao(this,arquitetura);
		
		janela =new Janela(this,nreg,nflag,flags);
	}
	
	//XXX: duvida no inicializa
	
	/**
	*Inicializa a janela do Simulador.
	*/
	public void inicializa()
	{
		janela.inicializa();	
	}
}